;    ATMEL

BAIT1		EQU	20H
	
RAZR0		EQU	30H
ESEK		EQU	31H
DSEK		EQU	32H
EMIN1		EQU	33H
DMIN1		EQU	34H
RAZR1		EQU	35H
EMIN            EQU     36H    ; 
DMIN            EQU     37H    ; 
ETHAS           EQU     38H    ; 
DTHAS           EQU     39H    ; 
RAZR2		EQU	3AH
BUD1            EQU     3BH    ; 
BUD2            EQU     3CH    ; 
BUD3            EQU     3DH    ; 
BUD4            EQU     3EH
RAZR3		EQU	3FH   ; 				
BUD11           EQU     40H    ; 
BUD21           EQU     41H    ; 
BUD31           EQU     42H    ; 
BUD41           EQU     43H 
RAZR4           EQU     44H ; 
ZAD1            EQU     45H
ZAD2            EQU     46H
ZAD3            EQU     47H
ZAD4            EQU     48H
RAZR5           EQU     49H
ESEKD           EQU     4AH
DSEKD           EQU     4BH
SSEKD           EQU     4CH
TSEKD		EQU	4DH

ZADER2		EQU	5FH

ZN1PW           BIT     20H.0
ZN2PW           BIT     20H.1
ZN3PW		BIT	20H.2
ZN4PW           BIT     20H.3
ZN5PW           BIT     20H.4
ZVPW		BIT	20H.5
V1PW		BIT	20H.6
V2PW	        BIT	20H.7

ZNAK2		BIT	28H.0
BUDS2           BIT     28H.1 
BUDK1           BIT     28H.2
BUDK2           BIT     28H.3
ZNAK3		BIT	28H.4
KNOP5		BIT	28H.5
BUDS3	  	BIT	28H.6
BIP	        BIT	28H.7

BUDS1           BIT     29H.0                       
ZNAK            BIT     29H.1
ZNAK1           BIT     29H.2
TERM1           BIT     29H.3
KNOP3		BIT	29H.4
FLAG4		BIT	29H.5
KNOP4	 	BIT	29H.6

PUSK            BIT     2AH.0 
PUSK1           BIT     2AH.1 
SIG             BIT     2AH.2
FLAG            BIT     2AH.3
FLAG1           BIT     2AH.4
FLAG2           BIT     2AH.5
KNOP2           BIT     2AH.6
FLAG3		BIT	2AH.7 

        JMP     INIT

        ORG     0BH
        JMP     OT                                                
INIT:
        CLR      A
	MOV	 BAIT1,#11111111B
        MOV      ESEK,#1        
        MOV      DSEK,#0
  	MOV      EMIN1,#0       
        MOV      DMIN1,#0
	MOV	 RAZR0,#1
        MOV      EMIN,#0        
        MOV      DMIN,#0        
        MOV      ETHAS,#0      
        MOV      DTHAS,#0
	MOV	 RAZR1,#2        
        MOV      BUD1,#0       
        MOV      BUD2,#0  
        MOV      BUD3,#0 
        MOV      BUD4,#0
	MOV	 RAZR2,#3      
     	MOV      BUD11,#0  
        MOV      BUD21,#0  
        MOV      BUD31,#0 
        MOV      BUD41,#0 
	MOV	 RAZR3,#4 
	MOV      ZAD1,#0       
        MOV      ZAD2,#0  
        MOV      ZAD3,#0 
        MOV      ZAD4,#0        
	MOV	 RAZR4,#5
	MOV      ESEKD,#0       
        MOV      DSEKD,#0  
        MOV      SSEKD,#0
 	MOV      TSEKD,#0 
	MOV	 RAZR5,#6 

	MOV      R0,#ESEK 
	MOV	 R1,#1
        MOV      R2,#00000001B 
        MOV      R3,#00000001B 
        MOV	 R4,#36 
        MOV      R5,#252
	MOV      R7,#1
        MOV      TMOD,#00000001B   
        MOV      TL0,#LOW(-80)
        MOV      TH0,#HIGH(-80)
	MOV      P3,#11111111B                                  
                                      
        CLR      PUSK  ;           
        CLR      PUSK1 ;                     
        CLR      FLAG             
        CLR      FLAG1            
        CLR      FLAG2
	CLR	 FLAG3
	CLR	 FLAG4                                          
        CLR      KNOP2
	CLR	 KNOP3 
	CLR	 KNOP4
	CLR	 TERM1          
        CLR      BUDS1
        CLR	 BUDS2
	SETB     BUDS3
        CLR      BUDK1
        CLR	 BUDK2
        CLR	 V1PW
	SETB	 V2PW
        SETB	 ZVPW               
        SETB     EA               
        SETB     ZNAK             
	SETB	 BIP
	SETB     TR0              
        SETB     ET0  

                                                                            
SE1:  	JNB      PUSK1,MIW10    
        JNB      PUSK,MIW10     
        CLR      PUSK 
	
	JB       P3.5,SLON1 
    	SETB     TERM1
	MOV      ESEKD,#0
	MOV      DSEKD,#0
	MOV      SSEKD,#0
        CLR      P3.0 
	CLR      P3.1 
	JMP      SEL1

MIW10:	JMP	 MIN10
SLON1:  JNB      TERM1,SEL1    
	
	SETB     P3.0
	CLR      BUDS3
	INC      ESEKD
 	MOV      A,ESEKD 
        CJNE     A,#10,SEL1 
        MOV      ESEKD,#0

	INC      DSEKD
 	MOV      A,DSEKD 
        CJNE     A,#10,SEL1 
        MOV      DSEKD,#0

 	INC      SSEKD
 	MOV      A,SSEKD 
        CJNE     A,#10,SEL1 
        MOV      ESEKD,#0
          
SEL1:   CPL      SIG
	JNB	 BIP,BI1
	SETB	 ZVPW
	CLR	 BIP
 
BI1:    INC      ESEK
        MOV      A,ESEK 
        CJNE     A,#10,MIN10 
        MOV      ESEK,#0
	SETB     ZVPW
 	JB	 BUDK1,BUL1
;	SETB	 V1PW
	CLR      BUDS1
BUL1:	JB	 BUDK2,BUL2
;	SETB	 V2PW           
	CLR	 BUDS2
	 
BUL2:   INC      DSEK 
        MOV      A,DSEK 
        CJNE     A,#6,MIN10 
        MOV      DSEK,#0 
     
EM:     INC      EMIN
	INC      EMIN1 
        MOV      A,EMIN 
        CJNE     A,#10,MIN10 
        MOV      EMIN,#0 
	MOV	 EMIN1,#0

DM:     INC      DMIN
	INC	 DMIN1 
        MOV      A,DMIN 
        CJNE     A,#6,MIN10 
        MOV      DMIN,#0 
	MOV	 DMIN1,#0
	INC	 ESEK
	SETB	 BIP
	CLR      ZVPW
ET:     INC      ETHAS 
        MOV      A,DTHAS 
        CJNE     A,#2,MIN1 
        
        MOV      A,ETHAS 
        CJNE     A,#4,MIN10 
D1:     MOV      EMIN,#0 
        MOV      DMIN,#0 
        MOV      ETHAS,#0 
        MOV      DTHAS,#0 
        JMP      SE1 

MIN1:   MOV      A,ETHAS 
        CJNE     A,#10,MIN10 
        MOV      ETHAS,#0 
DT:     INC      DTHAS 
        MOV      A,DTHAS 
        CJNE     A,#3,MIN333 
        JMP      D1
MIN333: JMP 	 SE1 

MIN10:  JB       BUDS1,MIS ;   t1
        MOV      A,BUD1 
        CJNE     A,EMIN,MIK10 
        MOV      A,BUD2 
        CJNE     A,DMIN,MIK10 
        MOV      A,BUD3 
        CJNE     A,ETHAS,MIK10 
        MOV      A,BUD4 
        CJNE     A,DTHAS,MIK10 
  	MOV	 A,DSEK
        CJNE     A,#0,MIK10
	MOV	 A,ESEK
	CJNE     A,#0,MIK10
        SETB     BUDS1
	CLR	 BUDK1
        CPL	 P3.7
	JB       P3.7,SPOK1
	SETB     V1PW 
 	CLR	 V2PW
	JMP	 MIS
SPOK1:	CLR      V1PW 
 	SETB	 V2PW     	
MIS:	JB       SIG,MIS1 
        SETB     ZVPW 
        JMP      MIK10 
MIS1:   CLR      ZVPW 


MIK10:  JB       BUDS2,MIS3 ;   t2
	MOV      A,BUD11 
        CJNE     A,EMIN,MIL10 
        MOV      A,BUD21 
        CJNE     A,DMIN,MIL10 
        MOV      A,BUD31 
        CJNE     A,ETHAS,MIL10 
        MOV      A,BUD41 
        CJNE     A,DTHAS,MIL10 
	MOV	 A,DSEK
        CJNE     A,#0,MIL10
 	MOV	 A,ESEK
	CJNE     A,#0,MIL10
        SETB     BUDS2
	CLR	 BUDK2
        CPL	 P3.7
	JB       P3.7,SPOK2
	SETB     V1PW 
 	CLR	 V2PW
	JMP      MIS3
SPOK2:	CLR      V1PW 
 	SETB	 V2PW     
		
MIS3:	JB       SIG,MIS21 
        SETB     ZVPW 
        JMP      MIL10 
MIS21:  CLR      ZVPW 

MIL10:  JB       BUDS3,MIR10   ;
	MOV      A,ZAD1 
        CJNE     A,ESEKD,MIR10 
        MOV      A,ZAD2 
        CJNE     A,DSEKD,MIR10 
        SETB     BUDS3
	SETB     P3.1
	MOV      ESEKD,#0
	MOV      DSEKD,#0
	MOV      SSEKD,#0
	CLR      TERM1

MIR10:  CJNE     R2,#00000010B,MIN101 ; 
        JNB      KNOP2,MIN111 
        CLR      KNOP2
        
DD1:    CJNE     R3,#00000010B,PE1
        JMP      EM
PE1:    CJNE     R3,#00000100B,PE2
        JMP      DM
PE2:    CJNE     R3,#00001000B,PE3                                                                     
        JMP      ET 
PE3:    CJNE     R3,#00010000B,MIN101
        JMP      DT
                    
MIN111: JMP      SE1

EM1:    INC      BUD1
        MOV      A,BUD1              
        CJNE     A,#10,MIN101       
        MOV      BUD1,#0
                                     
DM1:    INC      BUD2
        MOV      A,BUD2
        CJNE     A,#6,MIN101
        MOV      BUD2,#0
        
ETOS1:  INC      BUD3
        MOV      A,BUD3
        CJNE     A,#2,MIN11C
        
        MOV      A,BUD3
        CJNE     A,#4,MIN101
D11:    MOV      BUD1,#0         
        MOV      BUD2,#0
        MOV      BUD3,#0 
        MOV      BUD4,#0
        JMP      SE1
                  
MIN11C: MOV      A,BUD3
        CJNE     A,#10,MIN101
        MOV      BUD3,#0 
DT1:    INC      BUD4
        MOV      A,BUD4
        CJNE     A,#3,MIN111
        JMP      D11
        
MIN101: ;SETB     PUSK1
	CJNE     R2,#00000100B,MIN104
        JNB      KNOP2,MIN111 
        CLR      KNOP2
DD2:    CJNE     R3,#00000010B,PE11
        JMP      EM1
PE11:   CJNE     R3,#00000100B,PE21
        JMP      DM1                                                             
PE21:   CJNE     R3,#00001000B,PE31         
        JMP      ETOS1                        
PE31:   CJNE     R3,#00010000B,MIN111      
        JMP      DT1                                                          

EM11:   INC      BUD11
        MOV      A,BUD11              
        CJNE     A,#10,MIN104       
        MOV      BUD11,#0
                                     
DM11:   INC      BUD21
        MOV      A,BUD21
        CJNE     A,#6,MIN104
        MOV      BUD21,#0
        
ETOS11: INC      BUD31
        MOV      A,BUD31
        CJNE     A,#2,MIN12C
        
        MOV      A,BUD31
        CJNE     A,#0B4H,MIN104
D12:    MOV      BUD11,#0         
        MOV      BUD21,#0
        MOV      BUD31,#0 
        MOV      BUD41,#0
        JMP      SE1
                  
MIN12C: MOV      A,BUD31
        CJNE     A,#10,MIN104
        MOV      BUD31,#0 
DT11:   INC      BUD41
        MOV      A,BUD41
        CJNE     A,#3,MIN222
        JMP      D12
        
MIN104: CJNE     R2,#00001000B,MIN105
        JNB      KNOP2,MIN222 
        CLR      KNOP2
DD21:   CJNE     R3,#00000010B,PE111
        JMP      EM11
PE111:  CJNE     R3,#00000100B,PE211
        JMP      DM11                                                             
PE211:  CJNE     R3,#00001000B,PE311         
        JMP      ETOS11                        
PE311:  CJNE     R3,#00010000B,MIN222      
        JMP      DT11                       
MIN222: JMP      SE1

EMZ1:   INC      ZAD1
        MOV      A,ZAD1              
        CJNE     A,#10,MIN105       
        MOV      ZAD1,#0
                                     
DMZ1:   INC      ZAD2
        MOV      A,ZAD2
        CJNE     A,#9,MIN105
        MOV      ZAD1,#0
	MOV      ZAD2,#0

MIN105: CJNE     R2,#00010000B,MIN222
        JNB      KNOP2,MIN222 
        CLR      KNOP2
        CJNE     R3,#00000010B,PELO1
        JMP      EMZ1
PELO1:  CJNE     R3,#00000100B,MIN222
        JMP      DMZ1                 
                                         
OT:     CLR      TR0                      ;               
        MOV      TL0,#LOW(-80)         
        MOV      TH0,#HIGH(-80)        
        SETB     TR0                     
        PUSH     ACC 
                      
TIS3:	DJNZ     R4,OUT6
        MOV	 R4,#36                               
	DJNZ     R5,OT1                  
        SETB     PUSK                    
        JB       ZNAK1,EMOK   
        JNB      ZNAK,EMOK
        CLR      P3.3                                             
        MOV      R5,#252                  
OT1:    CJNE     R5,#125,EMOK1              
        SETB     P3.3                
        JMP      EMOK1
OUT6:	JMP	 OUT
SAS5:   JMP	 SA5                              
EMOK:   MOV      R5,252

EMOK1:  MOV	 P1,#11111110B ;  1 -  
	NOP
        JB       P3.4,S1
        JB       FLAG,SAS5 
        SETB     FLAG
        MOV      A,R2
        RL       A
        
        MOV      R2,A
        JB       ACC.4,KN1 
        JMP      SA5
KN1:    MOV      R2,#00000001B
        MOV      R0,#ESEK
        JMP      SA5
S1:     CLR      FLAG
        
SA1:   	MOV	 P1,#11111101B ;  2 -   

	NOP
        JB       P3.4,S2
        JB       FLAG1, SAK5 ;(SA5)
        SETB     FLAG1
        SETB     KNOP2
        JNB      BUDS1,SIX
        CLR      BUDS1
        SETB     ZVPW
SIX:	JNB      BUDS2,SA5
        CLR      BUDS2
        SETB     ZVPW

SAK5:   JMP      SA5
S2:     CLR      FLAG1
        
SA2:    MOV	 P1,#11111011B ;  3 -      
        JB       P3.4,S3 
        JB       FLAG2,SA5
        SETB     FLAG2
        MOV      A,R3  
        RL       A

        MOV      R3,A
        JB       ACC.5,KN2            
        JMP      SA5
KN2:    MOV      R3,#00000001B 
	MOV	 A,R2
        JNB      ACC.4,BU1
	SETB	 BUDK1

	JMP	 SA5
BU1:    JNB      ACC.5,SA5
	SETB	 BUDK2
	JMP      SA5
S3:     CLR      FLAG2
			
SA3:	MOV	 P1,#11110111B ;  4 -/
	NOP
        JB       P3.4,S4 
        JB       FLAG3,SA5
        SETB     FLAG3
	MOV      ESEKD,#0
	MOV      DSEKD,#0
	MOV      SSEKD,#0

	CPL	 PUSK1
	JNB      PUSK1,WER1  
	CLR      BUDS3
	JMP	 SA5
WER1:	SETB     BUDS3        
	JMP	 SA5

S4:	CLR	 FLAG3 

SA4:	MOV	 P1,#11101111B ;  5 -   
	NOP
        JB       P3.4,S5 
        JB       FLAG4,SA5
        SETB     FLAG4
        CPL	 P3.7
	JB       P3.7,SPOK
	SETB     V1PW 
 	CLR	 V2PW
	JMP	 SA5

SPOK:	CLR      V1PW 
 	SETB	 V2PW     
	JMP	 SA5
S5:	CLR	 FLAG4 

SA5:	SETB	 ZN1PW
	SETB	 ZN2PW
	SETB	 ZN3PW
	SETB	 ZN4PW
	SETB	 ZN5PW
        CJNE     R1,#1,FN0
	CLR	 ZN5PW
        JMP      FN11                                    
FN0:    CJNE     R1,#2,FN1
	CLR	 ZN4PW 
        JMP	 FN11
FN1:	CJNE     R1,#3,FN2
	CLR	 ZN3PW         
        JMP	 FN11       
FN2:	CJNE     R1,#4,FN3
	CLR	 ZN2PW         
        JMP	 FN11
FN3:	CJNE     R1,#5,FN11
	CLR	 ZN1PW	
FN11:	MOV	 A,BAIT1
	CLR	 P3.2
	MOV	 P1,A
	NOP
	SETB	 P3.2
	CJNE     @R0,#0,FROS0   
	MOV	 P1,#11000000B
	JMP	 FROS17
FROS0:	CJNE     @R0,#1,FROS1   
	MOV	 P1,#11111001B
	JMP	 FROS17
FROS1:	CJNE     @R0,#2,FROS2   
	MOV	 P1,#10100100B
	JMP	 FROS17
FROS2:	CJNE     @R0,#3,FROS3   
	MOV	 P1,#10110000B
	JMP	 FROS17
FROS3:	CJNE     @R0,#4,FROS4   
	MOV	 P1,#10011001B
	JMP	 FROS17
FROS4:	CJNE     @R0,#5,FROS5   
	MOV	 P1,#10010010B
	JMP	 FROS17
FROS5:	CJNE     @R0,#6,FROS6   
	MOV	 P1,#10000010B
	JMP	 FROS17
FROS6:	CJNE     @R0,#7,FROS7   
	MOV	 P1,#11111000B
	JMP	 FROS17
FROS7:	CJNE     @R0,#8,FROS8   
	MOV	 P1,#10000000B
	JMP	 FROS17
FROS8:	CJNE     @R0,#9,FROS9   
	MOV	 P1,#10010000B
	JMP	 FROS17
FROS9:	CJNE     @R0,#10,FROS10   
	MOV	 P1,#01110000B
	JMP	 FROS17
FROS10:	CJNE     @R0,#11,FROS11   
	MOV	 P1,#11001111B
	JMP	 FROS17
FROS11:	CJNE     @R0,#12,FROS13   
	MOV	 P1,#10100100B
	JMP	 FROS17
FROS13:	CJNE     @R0,#13,FROS14   
	MOV	 P1,#10000110B
	JMP	 FROS17
FROS14:	CJNE     @R0,#14,FROS15   
	MOV	 P1,#10001011B
	JMP	 FROS17
FROS15:	CJNE     @R0,#20,FROS17   
	MOV	 P1,#11111111B
		                         
FROS17: CJNE     R0,#EMIN,TE11           
TES1:   CJNE     R3,#00000010B,THAS                           
        JMP      THAS1                    
TE11:   CJNE     R0,#BUD1,TEV1            
        JMP      TES1                    
TEV1:   CJNE     R0,#BUD11,TOL1            
        JMP      TES1 
TOL1:   CJNE     R0,#ZAD1,TE1            
        JMP      TES1       
                                
TE1:    CJNE     R0,#DMIN,TE21           
TES2:   CJNE     R3,#00000100B,THAS                          
        JMP      THAS1                    
TE21:   CJNE     R0,#BUD2,TEV2            
        JMP      TES2                    
TEV2:   CJNE     R0,#BUD21,TOL2            
        JMP      TES2  
TOL2:   CJNE     R0,#ZAD2,TE2            
        JMP      TES2        
                                       
TE2:    CJNE     R0,#ETHAS,TE31          
TES3:   CJNE     R3,#00001000B,THAS                          
        JMP      THAS1                    
TE31:   CJNE     R0,#BUD3,TEK3            
        JMP      TES3
TEK3:   CJNE     R0,#BUD31,TOL3            
        JMP      TES3                 
TOL3:   CJNE     R0,#ZAD3,TE3            
        JMP      TES3                                
                             
TE3:    CJNE     R0,#DTHAS,TE41          
TES4:   CJNE     R3,#00010000B,THAS                          
        JMP      THAS1                    
TE41:   CJNE     R0,#BUD4,TEK4           
        JMP      TES4 
TEK4:   CJNE     R0,#BUD41,TOL4           
        JMP      TES4 
TOL4:   CJNE     R0,#ZAD4,THAS            
        JMP      TES4         
                                                                  
THAS1:  XRL	 P1,#10000000B

THAS:   INC      R0
       	INC	 R1
	INC	 R7
        MOV      A,R2
        JB       ACC.0,TEMO0
        JB       ACC.1,TEMO1
        JB       ACC.2,TEMO2
        JB       ACC.3,TEMO3
        JB       ACC.4,TEMO4
	JB       ACC.5,TEMO5

TEMO0:  CJNE     R0,#35H,OUT
        MOV      R0,#RAZR0
	MOV	 R1,#1 
        JMP      OUT

TEMO1:  CJNE     R0,#3AH,OUT
        MOV      R0,#RAZR1
	MOV	 R1,#1            
        JMP      OUT
         
TEMO2:  CJNE     R0,#3FH,OUT
        MOV      R0,#RAZR2
	MOV	 R1,#1
        JMP      OUT
                 
TEMO3:  CJNE     R0,#44H,OUT
        MOV      R0,#RAZR3
	MOV	 R1,#1
        JMP      OUT

TEMO4:  CJNE     R0,#49H,OUT
        MOV      R0,#RAZR4
	MOV	 R1,#1
	JMP      OUT

TEMO5:  CJNE     R0,#4EH,OUT
        MOV      R0,#RAZR5
	MOV	 R1,#1 
OUT:	POP     ACC                                                                               
        RETI

	END


