;  
; ( AT89C4051-24PI)

EMIN	 	EQU	22H
DMIN	 	EQU	23H
EMIN1	 	EQU	24H
DMIN1	 	EQU	25H
	
REZ		EQU	30H
ZADER		EQU	31H
EMINB		EQU	32H
DMINB		EQU	33H
EMINB1		EQU	34H
DMINB1		EQU	35H
	  
ZVPW		BIT	21H.0
PUSKB		BIT	21H.1
PUSKS1		BIT	21H.2;;
PUSKS2		BIT	21H.3;;
PUSKS3		BIT	21H.4;;
PUSKS4		BIT	21H.5;;

KNOPB1		BIT	28H.0
KNOPM1          BIT     28H.1 
KNOPB           BIT     28H.2                       
KNOPM           BIT     28H.3

PUSK            BIT     2AH.0 
PUSK1           BIT     2AH.1 
KLAV            BIT     2AH.2
FLAG            BIT     2AH.3
FLAG1           BIT     2AH.4
FLAG2           BIT     2AH.5
FLAG3	        BIT     2AH.6

KNOPS		BIT	2BH.0
FLAGS		BIT	2BH.1
REZRB	  	BIT	2BH.2
GEL		BIT     2BH.3
GEL1		BIT     2BH.4

        JMP     INIT
        ORG     0BH
        JMP     OT
                                                
INIT:   CLR      A
	MOV	 P3,#11111111B 
	MOV	 R0,#EMIN
	MOV	 R1,#255 
        MOV      R2,#5         
        MOV	 R3,#10
	MOV      R4,#5 ;;  
	MOV      R5,#5 ;;  
	MOV      R6,#5 ;; 
	MOV      R7,#5 ;;  
        MOV      TMOD,#00000001B   
        MOV      TL0,#LOW(-310)
        MOV      TH0,#HIGH(-310)                
	MOV	 EMIN,#070H
	MOV	 DMIN,#0B0H
	MOV	 EMIN1,#0D0H
	MOV	 DMIN1,#0E0H
	
        CLR      FLAG             
        CLR      FLAG1            
        CLR      FLAG2
	CLR	 FLAG3
	CLR      FLAGS                                           
   	CLR      GEL 
        CLR      GEL1 
	SETB	 ZVPW

	CLR	 KNOPB
	CLR	 KNOPM
	CLR	 KNOPB1
	CLR	 KNOPM1
	SETB	 REZRB

	CLR	 PUSK
	CLR	 PUSK1
	CLR	 PUSKB
	SETB	 PUSKS2 ;;
	SETB	 PUSKS4 ;;

	SETB     TR0              
        SETB     ET0  
        SETB     EA 
 
	MOV	 P1,#11111110B	;  1( )
	NOP
	NOP
        JB       P3.0,SE1
	MOV	 P3,#11111111B 
;	SETB     GEL1
        SETB     GEL
	CPL      P3.5
	MOV	 P3,#11111111B 
 

SE1:	JNB     GEL,SD1 	 ;    
 	JNB     PUSK,SE1   	 ;     
        CLR     PUSK 

        CPL     P3.5 
	JMP	SE1

                                                          
SD1:   	JNB     PUSK1,MINS1   	;   

SE2:    JNB     PUSK,MINS1   	 ;     
        CLR     PUSK 

	JB	REZRB,SES4

;  

	MOV	A,EMIN		;  
	CJNE    A,#70H,EMN1
	MOV	A,DMIN	
	CJNE    A,#0B0H,EMN1

	JNB     PUSKS2,S02   	;   .2
	DJNZ	R4,DD66	
	MOV     R4,#5
	CLR	PUSKS2
	JMP	SE1
DD66:	CPL	P3.4
	JMP	SE1
MINS1:	JMP	MIN1
SES4:	JMP	SE4

S02:	SETB	P3.4
	CLR	P3.5
	JNB     PUSKS1,SE1 
	CLR	PUSKS1
	DJNZ	R5,SE1	
	MOV     R5,#5
	SETB    P3.1
	SETB	P3.5
	CLR	P3.3
	CLR	P3.2
	SETB	PUSKS2
	MOV	EMIN,EMINB	
	MOV	DMIN,DMINB	
	SETB	REZRB
	JMP	SE1
;	CLR     KNOPS

EMN1:	MOV	A,EMIN		;   
	CJNE    A,#70H,EM1
	MOV	A,DMIN
	CJNE    A,#0B0H,EM1
	CLR	ZVPW
	JMP	MIN1

EM1:	DEC	EMIN
	MOV	A,EMIN
	CJNE    A,#6FH,MIN1;EM11
	MOV	EMIN,#79H
;	JMP	DM1
;EM11:	DEC	EMIN	
;	CJNE    A,#0E0H,MIN1

DM1:	MOV	A,DMIN
	CJNE    A,#0B0H,DM11
	JMP	SE1
	CLR	ZVPW
DM11:	DEC 	DMIN
	CJNE    A,#0B0H,DM13
	CLR	ZVPW
DM13:	JMP	SE1

EMN2:	MOV	A,EMIN		;   
	CJNE    A,#79H,EM2
	MOV	A,DMIN
	CJNE    A,#0B9H,EM2
	JMP	MIN1
EM2:	INC	EMIN
	MOV	A,EMIN
	CJNE    A,#07AH,MIN1
	MOV	EMIN,#070H

DM2:	MOV	A,DMIN
	CJNE    A,#0B9H,DM21
	JMP	MIN1
DM21:	INC 	DMIN
	JMP	MIN1

MIN1: 	JB	REZRB,MINS3
	JNB	KNOPM,SLED
	CLR	KNOPM
	JMP	EMN1
SLED:	JNB	KNOPB,SES1
	CLR	KNOPB
	JMP	EMN2
SES1:   JMP     SE1
MINS3:  JMP     MIN3
;  

;SE4:    JNB     PUSK1,MIN3 

SE4:	MOV	A,EMIN1		;   
	CJNE    A,#0D0H,EMN3
	MOV	A,DMIN1	
	CJNE    A,#0E0H,EMN3

;	JNB     KNOPS,EMN3
;	CLR     P3.2
;	CLR	P3.3
	JNB     PUSKS4,S04   	;   .1
	DJNZ	R6,DD67	
	MOV     R6,#5
	CLR	PUSKS4
	JMP	SE1
DD67:	CPL	P3.2
	JMP	SE1

S04:	SETB	P3.2
	CLR	P3.5
	JNB     PUSKS3,SEL1 
	CLR	PUSKS3
	DJNZ	R7,SEL1	
	MOV     R7,#5
	CLR     P3.1 ;  1
	SETB	P3.5 ; 
	SETB	P3.3 ;  2
	CLR	P3.4 ; 2
	SETB	PUSKS4
	MOV	EMIN1,EMINB1	
	MOV	DMIN1,DMINB1	
	CLR	REZRB	
SEL1:	JMP     SE1
;	CLR     KNOPS

EMN3:	MOV	A,EMIN1		;   
	CJNE    A,#0D0H,EM3
	MOV	A,DMIN1
	CJNE    A,#0E0H,EM3
	CLR	ZVPW
	JMP	MIN3

EM3:	DEC	EMIN1
	MOV	A,EMIN1
	CJNE    A,#0CFH,MIN3;EM1
	MOV	EMIN1,#0D9H
;	JMP	DM1
;EM11:	DEC	EMIN	
;	CJNE    A,#0E0H,MIN1

DM3:	MOV	A,DMIN1
	CJNE    A,#0E0H,DM31
	JMP	SE1
	CLR	ZVPW
DM31:	DEC 	DMIN1
	CJNE    A,#0E0H,DM33
	CLR	ZVPW
DM33:	JMP	SE1

EMN4:	MOV	A,EMIN1		;   
	CJNE    A,#0D9H,EM4
	MOV	A,DMIN1
	CJNE    A,#0E9H,EM4
	JMP	MIN3
EM4:	INC	EMIN1
	MOV	A,EMIN1
	CJNE    A,#0DAH,MIN3
	MOV	EMIN1,#0D0H

DM4:	MOV	A,DMIN1
	CJNE    A,#0E9H,DM41
	JMP	MIN3
DM41:	INC 	DMIN1
	JMP	MIN3

MIN3: 	JNB	KNOPM1,SLED2
	CLR	KNOPM1
	JMP	EMN3
SLED2:	JNB	KNOPB1,MIL10
	CLR	KNOPB1
	JMP	EMN4
MIL10:  JMP     SE1
                                                             	
OT:     CLR      TR0  		;     TR0                  
        MOV      TL0,#LOW(-310)         
        MOV      TH0,#HIGH(-310)     
        SETB     TR0                     
        PUSH     ACC 

SER1:	DJNZ	R1,OUT1
	MOV	R1,#255
	DJNZ	R2,OUT1	
	MOV     R2,#5
	SETB	PUSK		;  1 .
	SETB	PUSKS1
	SETB	PUSKS3
	
OUT1:	DJNZ	R3,SAK5 ;SA5
	MOV	R3,#10

	MOV	 P1,#11111110B	;  1( )
	NOP
        JB       P3.0,S1

        JB       FLAG,SAK5 
        SETB     FLAG
	JB	 REZRB,KK1
	SETB	 KNOPB
SAK5:	JMP	 SA5

KK1:	SETB	 KNOPB1
	JMP	 SA5
S1:     CLR      FLAG

SA1:   	MOV	 P1,#11111101B        ;  2( )
	NOP
        JB       P3.0,S2
        JB       FLAG1,SAK5 ;(SA5)
        SETB     FLAG1
	JB	 REZRB,KK2
	SETB	 KNOPM
	JMP	 SA5

KK2:	SETB	 KNOPM1	
	JMP      SA5
S2:     CLR      FLAG1 
      
SA2:    MOV	 P1,#11111011B		;  3 ( )
        JB       P3.0,S3 
        JB       FLAG2,SA5 ;(SA5)
        SETB     FLAG2
	CPL 	 REZRB	
	JB       REZRB,SSS1
 	MOV	 EMINB,EMIN	
	MOV	 DMINB,DMIN
	MOV	 EMINB1,EMIN1	
	MOV 	 DMINB1,DMIN1
;	SETB	 P3.4
;	CLR	 P3.5
	JMP	 SA5
SSS1:	MOV	 EMINB1,EMIN1	
	MOV 	 DMINB1,DMIN1
	MOV	 EMINB,EMIN	
	MOV	 DMINB,DMIN
;	CLR	 P3.4
;	SETB	 P3.5
	JMP      SA5
S3:     CLR      FLAG2
			
SA3:	MOV	P1,#11110111B		;  4 (/)
	NOP
        JB      P3.0,S4 
        JB      FLAG3,SA5
        SETB    FLAG3
	CPL	PUSK1
	JNB     PUSK1,KIN1   
	CLR	REZRB
	CLR     P3.1 ;;
	CLR	P3.4 ;;	
	MOV	EMIN,EMINB	
	MOV	DMIN,DMINB
	MOV	EMIN1,EMINB1	
	MOV 	DMIN1,DMINB1	
;	CLR	P3.5
;	SETB	P3.4
	JMP     SA5

KIN1:	SETB    REZRB
	MOV	EMIN,EMINB	
	MOV	DMIN,DMINB
	MOV	EMIN1,EMINB1	
	MOV 	DMIN1,DMINB1
	MOV	P3,#11111111B
	JMP     SA5
S4:	CLR	FLAG3 
SA5:   	
	MOV	 P1,#11111110B	;  1( )
	NOP
	NOP
        JB       P3.0,S5
	MOV	 P1,#11111101B        ;  2( )
	NOP
	NOP
        JB       P3.0,S5
        JB       GEL1,SA6
	SETB     GEL1
        CPL      GEL
	CPL      P3.5
	JMP      SA6
S5:	CLR      GEL1


SA6:	INC 	R0
	CJNE    R0,#26H,SOUT
	MOV	R0,#EMIN
SOUT:	MOV	P1,@R0
	SETB    P3.7
	JB	REZRB,SEKL4
	JNB	P1.4,HOL
	CLR     P3.7
	JMP     HOL
SEKL4:	JNB	P1.6,HOL
	CLR     P3.7	
HOL:	POP     ACC                                                                               
        RETI

	END